package eu.eudat.services;

import eu.eudat.dao.entities.DMPDao;
import eu.eudat.dao.entities.InvitationDao;
import eu.eudat.entities.DMP;
import eu.eudat.entities.Invitation;
import eu.eudat.models.userinfo.UserInfo;
import eu.eudat.models.userinfo.UserInfoInvitationModel;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.UUID;

/**
 * Created by ikalyvas on 1/4/2018.
 */
@Service("invitationService")
public class InvitationServiceImpl implements InvitationService {
    @Override
    public void assignToDmp(DMPDao dmpDao, List<eu.eudat.entities.UserInfo> users, DMP dmp) {
        for(eu.eudat.entities.UserInfo user : users){
            dmp.getUsers().add(user);
        }
        dmpDao.createOrUpdate(dmp);
    }

    @Override
    public void assignToDmp(DMPDao dmpDao, eu.eudat.entities.UserInfo user, DMP dmp) {
        dmp.getUsers().add(user);
        dmpDao.createOrUpdate(dmp);
    }

    @Override
    public void createInvitations(InvitationDao invitationDao, List<eu.eudat.entities.UserInfo> users, DMP dmp, eu.eudat.entities.UserInfo creator) {
        for(eu.eudat.entities.UserInfo userInfo : users){
            Invitation invitation = new Invitation();
            invitation.setDmp(dmp);
            invitation.setInvitationEmail(userInfo.getEmail());
            invitation.setUser(creator);
            invitation.setToken(UUID.randomUUID());
            invitation.setAcceptedInvitation(userInfo.getId()!=null);
            invitationDao.createOrUpdate(invitation);
        }
    }

    @Override
    public void sendInvitations(List<UserInfoInvitationModel> users) {

    }
}
